﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
	
	
#End Region



Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Public Localisation_Home As String=""
	Dim phone1 As Phone
	Public level_battery As Int=0
	Public Local_sensor As String=""
	Public T_consigne As String=""
	Public nb_sensor As Int=0
	Public Download_File_HH, Upload_File_HH,Download_Setup_HH,Load_Data_SAV_HH,Save_Data_SAV_HH As Int
	Public Macaddress As String
	Public Timer1 As Timer
	Public Timer2 As Timer
	
	Download_File_HH=1
	Upload_File_HH=2
	Download_Setup_HH=3
	Load_Data_SAV_HH=5
	Save_Data_SAV_HH=6
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private clv_sensor As CustomListView
	Dim cs As CSBuilder
	
	
	Private Btn_setup_sensor As B4XView
	Private lbl_icone_sensor As B4XView
	Private lbl_name As B4XView
	Private lbl_T_Consigne As B4XView
	Private lbl_T_live As B4XView
	Private Lbl_alerte As B4XView
	Private Lbl_alerte1 As B4XView
	
	
	
	Dim filetotransfert As String=""
	Private lbl_icone_humidity As B4XView
	Private lbl_H_live As B4XView
	
	
	Private Lbl_update As B4XView
	Private Old_Data As Boolean=False
	
	Private Btn_save_sensor As B4XView
	Private  save_data_sav As Boolean=False
	Private Btn_trash As B4XView
	Private Lbl_verif_data_cloud As B4XView
	Private Btn_conso As B4XView
	Private lbl_conso As B4XView
	Private Btn_graphe As B4XView
	Private Btn_alert As B4XView
	Private Var_temp As RoundSlider
End Sub



Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("HomeControl1")
	Timer1.Initialize("timer1", 15000)
	Timer2.Initialize("timer2", 300)
	' Chargement de la configuration et des datas sur le serveur.
	
	If Main.new_location=False Then ' Si ce n'est pas une nouvelle configuration
		If IsPaused(Transfert_Server)=True Then
			Lbl_verif_data_cloud.Visible=True
			Main.type_transfert=Download_Setup_HH
			StartService(Transfert_Server)
		End If
	End If
	
End Sub

Sub Activity_Resume
	If Setup_Power_connected.Update_data_sensor_enable=True Then
		Lbl_verif_data_cloud.Visible=True
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub lbAddSensor_Click
	StartActivity(Setup)
End Sub


Sub Timer2_Tick
	If Lbl_verif_data_cloud.Visible=True Then
		Lbl_verif_data_cloud.Visible=False
		Lbl_verif_data_cloud.RequestFocus
	Else
		Lbl_verif_data_cloud.Visible=True
		Lbl_verif_data_cloud.RequestFocus
	End If
End Sub

Sub Timer1_Tick
	
	If Setup_Power_connected.Update_data_sensor_enable=False Then 'Stop le timer une fois le fichier téléchargé
		Timer1.Enabled=False
		Timer2.Enabled=False
	Else
'		If Timer2.Enabled=False Then
'			Timer2.Enabled=True
'		End If
		
		If IsPaused(Transfert_Server)=True Then
			Lbl_verif_data_cloud.Visible=True
			Main.type_transfert=Download_Setup_HH
			StartService(Transfert_Server)
		End If
	End If
	
End Sub


Sub load_sensor(success As Boolean)
	
	Dim sav_file As Boolean=False
	
	
	clv_sensor.Clear
	
	If Timer2.Enabled=True Then
		Timer2.Enabled=False
	End If
	
	 save_data_sav=True
	 
	Lbl_verif_data_cloud.Visible=False
	
	' Chargement des valeurs sauvegardées
	Main.type_transfert=Load_Data_SAV_HH
	filetotransfert=Main.Localisation_Home & "_" & "Data_Live_Sensor_sav.txt"
					
	Wait For (Param.read_file_setup(filetotransfert)) complete (result As Boolean)
	
	If result=True Then
		sav_file=True
	End If
	
	
	If success=True Then
		'nb_sensor=0
		For i=0 To Main.list_Read_data_sensor.Size-1
			Old_Data=False
			Dim data() As String =Regex.Split(";", Main.list_Read_data_sensor.Get(i))
		
			If data(0).Contains("[")=False Then
				'nb_sensor=nb_sensor+1
				
				' data(3)= T Live
				' data(4)= H_Live
				' data(5)= T_Consigne
				' data(6)= Batterie
				' data(7)= Date
				'data(6)="-"
				If sav_file=True Then 'Si un fichier historique existe on l'utilise si jamais des données sont manquantes
								
					If data(3)="-" Or data(6)="-" Then 'Si pas d'info de température ou batterie on recharge les dernières données sauvegardées 
							
						If data(3)="-" Then
							
								For i1=0 To Main.list_Read_data_sav.Size-1
									Dim data_sav() As String =Regex.Split(";", Main.list_Read_data_sav.Get(i1))
							
									If data_sav(2)=data(2) Then
										Old_Data=True 'Surligne en rouge la date obsolète de la mesure de température
										Dim info_sensor As String=data(1) &";" & data(2) &";" & data_sav(3) &";" & data_sav(4) &";" & data_sav(5) &";" & data_sav(6) &";" & data_sav(7)
										clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
										Main.list_Read_data_sav.Set(i1,data(0) &";" & info_sensor) 'Met à jour la table
										'save_data_sav=True
										Exit
									End If
								Next
										
						End If
							
						If data(6)="-" Then ' Si pas d'info batterie, on recharge la dernière donnée sauvegardée
														
								For i1=0 To Main.list_Read_data_sav.Size-1
									Dim data_sav() As String =Regex.Split(";", Main.list_Read_data_sav.Get(i1))
								
									If data_sav(2)=data(2) Then
										Dim info_sensor As String=data(1) &";" & data(2) &";" & data(3) &";" & data(4) &";" & data(5) &";" & data_sav(6) &";" & data(7)
										clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
										Main.list_Read_data_sav.Set(i1,data(0) &";" & info_sensor)
										'Param.list_Read_data_sav=Param.list_read 'Recopie les données dans le tableau de data à sauvegarder
										'save_data_sav=True
										Exit
									End If
								Next
		'											
						End If
												
					Else
						Dim find_sensor As Boolean=False			
						For i1=0 To Main.list_Read_data_sav.Size-1
							Dim data_sav() As String =Regex.Split(";", Main.list_Read_data_sav.Get(i1))
							
							If data_sav(2)=data(2) Then
								Dim info_sensor As String=data(1) &";" & data(2) &";" & data(3) &";" & data(4) &";" & data(5) &";" & data(6) &";" & data(7)
								clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
								Main.list_Read_data_sav.Set(i1,data(0) &";" & info_sensor)
								find_sensor=True
								'save_data_sav=True
								Exit
							End If
						Next
							
						If find_sensor=False Then 'Si le sensor n'est pas trouvé dans la sauvegarde, ajout du nouveau sensor
							Dim info_sensor As String=data(1) &";" & data(2) &";" & data(3) &";" & data(4) &";" & data(5) &";" & data(6) &";" & data(7)
							clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
							Main.list_Read_data_sav.Set(i1,data(0) &";" & info_sensor)
						End If
						
					End If
				Else
					
'					If data(3)="-"  Then 'Si un température est absente, pas de sauvegarde
'						save_data_sav=False
'					End If
					
					If  data(6)="-" Then 'Fixe à 100 la valeur de la batterie si pas d'info
						data(6)="100"
					End If
'					
'				
					Dim info_sensor As String=data(1) &";" & data(2) &";" & data(3) &";" & data(4) &";" & data(5) &";" & data(6) &";" & data(7)
					clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
					
'					If Main.list_Read_data_sav.IsInitialized=False Then
'						Main.list_Read_data_sav.Initialize
'						Main.list_Read_data_sav.Clear
'					End If
					Main.list_Read_data_sav.add(data(0) &";" & info_sensor)
				End If
			
			End If
			
		Next
		
		
		If save_data_sav=True And Main.list_Read_data_sav.Size<>0 Then 'Si les nouvelles données sont ok on les sauvegarde
		
				Main.type_transfert=Save_Data_SAV_HH
				filetotransfert=Main.Localisation_Home & "_" & "Data_Live_Sensor_sav.txt"
				wait for (Param.write_file_setup(Main.list_Read_data_sav,filetotransfert,False,False)) complete (result As Boolean)
				save_data_sav=False
						
		Else
			save_data_sav=False
			alerte(True)
		End If
				
	Else 'si on ne peut pas télécharger les données on charge celles sauvegardées
		
		Main.type_transfert=Load_Data_SAV_HH
		filetotransfert=Main.Localisation_Home & "_" & "Data_Live_Sensor_sav.txt"
		Wait For (Param.read_file_setup(filetotransfert)) complete (result As Boolean)
					
		If result=True Then
			Try
				For i=0 To Main.list_Read_data_sav.Size-1
					Dim data_sav() As String =Regex.Split(";", Main.list_Read_data_sav.Get(i))
						
					Dim info_sensor As String=data_sav(1) &";" & data_sav(2) &";" & data_sav(3) &";" & data_sav(4) &";" & data_sav(5) &";" & data_sav(6) &";" & data_sav(7)
					clv_sensor.add(CreateListItem(info_sensor, clv_sensor.AsView.Width, 120dip),"")
				Next
			Catch
				alerte(False)
			End Try
			
		Else
			alerte(False)
		End If
		save_data_sav=False
		
	End If
				
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
	
	
	Select KeyCode
		Case KeyCodes.KEYCODE_VOLUME_UP
			Log("Up")
			Return True
					
		Case KeyCodes.KEYCODE_VOLUME_DOWN
			Log("Down")
			Return True
		Case KeyCodes.KEYCODE_BACK
'			confirme_retour=confirme_retour+1
'			If confirme_retour=2 Then
'				
			'Return True
'				confirme_retour=0
'				
'			Else
'				ToastMessageShow("Appuyer sur la touche retour une seconde fois pour quitter.",True)
'			End If
			
			If save_data_sav = False Then
				Return False
			Else
				ToastMessageShow("Veuillez patienter...",True)
				Return True
			End If
		
			'Return True
	End Select
End Sub

Sub load_setup(success As Boolean)
	
	If success=True Then
		nb_sensor=0
		For i=0 To Main.list_Read_Setup.Size-1
			Dim data() As String =Regex.Split(";", Main.list_Read_Setup.Get(i))
			
			If data(0).Contains("[")=False Then
				nb_sensor=nb_sensor+1
			End If
		Next
	End If	
	
End Sub

Sub alerte (success As Boolean)
	If success=False Then
		Lbl_alerte.Visible=True
		Lbl_alerte1.Visible=True
	Else
		Lbl_alerte.Visible=False
		Lbl_alerte1.Visible=False
	End If
	
	
End Sub



Sub CreateListItem(Text As String, Width As Int, Height As Int) As Panel
	Dim xui As XUI
	Dim p As B4XView =xui.CreatePanel("")
	Dim info_temp() As String=Regex.Split(";",Text)
	'p.Initialize("")
	'we need to add the panel to a parent to set its dimensions. It will be removed after the layout is loaded.
	'Activity.AddView(p, 0, 0, Width, Height)
	'p.SetLayout(0, 0, Width, Height)
	p.SetLayoutAnimated(0,0,0,Width,Height)
	p.LoadLayout("List_sensor")
	
	lbl_name.Text=""
	lbl_T_live.Text=""
	lbl_H_live.Text=""
	lbl_T_Consigne.Text=""
	lbl_T_live.Tag=""
	level_battery=0
	
	
	If Old_Data=True Then
		Lbl_update.TextColor=Colors.Red
	Else
		Lbl_update.TextColor=Colors.Black
	End If
	
	'SwiftButton_setup.Tag= clv_sensor.Size
	'label1 and button1 will point to the last added views.
	
	Try
		
		lbl_icone_sensor.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF01FF20).Size(40).Append(Chr(0xF2C9) ).PopAll
		lbl_icone_humidity.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(30).Append(Chr(0xF043) ).PopAll
		
		If info_temp.Length=7 Then 'Vérifie de la bonne dimension du tableau
			
			DateTime.DateFormat="dd MMM yyyy HH:mm:ss"
			Dim time_data As Long= info_temp(6)
			Lbl_update.Text=DateTime.Date(time_data)
			lbl_name.Text=info_temp(0)
			lbl_name.tag=info_temp(1)
			
			If info_temp(2)<>"-" Then
								
				lbl_T_live.Text = info_temp(2).SubString(2) & "°C" 'Température Live
				lbl_H_live.Text= info_temp(3).SubString(2) & "%" 'Hydrométrie
			Else
				lbl_T_live.Text =cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(20).Append(Chr(0xF071) ).PopAll
				lbl_H_live.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(20).Append(Chr(0xF071) ).PopAll
			End If
				
			
			lbl_T_Consigne.Tag= info_temp(4)
			lbl_T_Consigne.Text = "T Max: " & info_temp(4) & "°C"' Round2(info_temp(4),1) & "°C" 'Round2(info_temp(3),1) & "°C"
			lbl_T_live.Tag= info_temp(5).Replace("%","") 'Mémorise le niveau de batterie dans le tag de la température
			
		Else
			lbl_icone_sensor.Text=cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(40).Append(Chr(0xF071) ).PopAll
		End If
		
		
	Catch
		Log(LastException)
		
	End Try
	
	
	Return p
	
End Sub

Sub Btn_setup_sensor_Click
	
	Dim Index_Sensor As Int= clv_sensor.GetItemFromView(Sender)
	Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
	Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
	
	If lbl.Tag="-" Then
		level_battery = 100 'Fixe le niveau à 100% si la toute première mesure est ko
	Else
		level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
	End If
	
	
	lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
	Local_sensor=lbl.Text
	Macaddress=lbl.tag
	lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
	T_consigne=lbl.tag
	StartActivity(Setup_Power_connected)
	
End Sub


Sub Btn_conso_Click
	Dim Index_Sensor As Int= clv_sensor.GetItemFromView(Sender)
	Dim pnl As Panel = clv_sensor.GetPanel(Index_Sensor)
	Dim lbl As Label = pnl.GetView(1) 'Récupère le label lbl_T_live de la selection
	
	If lbl.Tag="-" Then
		level_battery = 100 'Fixe le niveau à 100% si la toute première mesure est ko
	Else
		level_battery = lbl.Tag 'Récupère la valeur dans le label lbl Temp Live
	End If
	
	
	lbl = pnl.GetView(3) 'Récupère la valeur dans le label lbl localisation
	Local_sensor=lbl.Text
	Macaddress=lbl.tag
	lbl = pnl.GetView(2) 'Récupère la valeur dans le label lbl Temp Consigne
	T_consigne=lbl.tag
	StartActivity(Power_Interface)
End Sub

Sub Btn_graphe_Click
	
End Sub

Sub Btn_alert_Click
	
End Sub

